Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -899,115 +983,568 @@
 ;;; for example, inserting spaces into `intfoo () {}'.
 ;;;
 
-
-;; The user level functions
+(eval-when-compile
+  ;;
+  ;; We don't do this at the top-level as we only use non-autoloaded macros.
+  (require 'cl)
+  ;;
+  ;; Borrowed from lazy-lock.el.
+  ;; We use this to preserve or protect things when modifying text properties.
+  (defmacro save-buffer-state (varlist &rest body)
+    "Bind variables according to VARLIST and eval BODY restoring buffer state."
+    `(let* ,(append varlist
+		    '((modified (buffer-modified-p)) (buffer-undo-list t)
+		      (inhibit-read-only t)
+		      ;; FSF 21.2: (inhibit-point-motion-hooks t)
+		      ;; FSF 21.2: (inhibit-modification-hooks t)
+		      ;; FSF 21.2: deactivate-mark
+		      buffer-file-name buffer-file-truename))
+       ,@body
+       (when (and (not modified) (buffer-modified-p))
+	 (set-buffer-modified-p nil))))
+  (put 'save-buffer-state 'lisp-indent-function 1)
+  ;; FSF 21.2: (def-edebug-spec save-buffer-state let)
+  ;;
+  ;; Shut up the byte compiler.
+  (defvar font-lock-face-attributes))	; Obsolete but respected if set.
 
 ;;;###autoload
-(defun font-lock-mode (&optional arg)
+(define-minor-mode font-lock-mode
   "Toggle Font Lock Mode.
-With arg, turn font-lock mode on if and only if arg is positive.
-
-When Font Lock mode is enabled, text is fontified as you type it:
-
- - Comments are displayed in `font-lock-comment-face';
- - Strings are displayed in `font-lock-string-face';
- - Documentation strings (in Lisp-like languages) are displayed in
+With arg, turn Font Lock mode off if and only if arg is a non-positive
+number; if arg is nil, toggle Font Lock mode; anything else turns Font
+Lock on.
+\(Font Lock is also known as \"syntax highlighting\".)
+
+When Font Lock mode is enabled, text is fontified as you type it, in the
+following faces:
+
+ - Comments in `font-lock-comment-face';
+ - Strings in `font-lock-string-face';
+ - Documentation strings (in Lisp-like languages) in
    `font-lock-doc-string-face';
- - Language keywords (\"reserved words\") are displayed in
-   `font-lock-keyword-face';
- - Function names in their defining form are displayed in
-   `font-lock-function-name-face';
- - Variable names in their defining form are displayed in
-   `font-lock-variable-name-face';
- - Type names are displayed in `font-lock-type-face';
- - References appearing in help files and the like are displayed
-   in `font-lock-reference-face';
- - Preprocessor declarations are displayed in
-  `font-lock-preprocessor-face';
+ - Language keywords (\"reserved words\") in `font-lock-keyword-face';
+ - Builtins in `font-lock-builtin-face';
+ - Function names in their defining form in `font-lock-function-name-face';
+ - Variable names in their defining form in `font-lock-variable-name-face';
+ - Type and class names in `font-lock-type-face';
+ - Constants and label names in `font-lock-constant-face';
+ - Things that should stand out in `font-lock-warning-face';
+ - Preprocessor declarations in `font-lock-preprocessor-face';
 
    and
 
  - Certain other expressions are displayed in other faces according
    to the value of the variable `font-lock-keywords'.
+
+To customize the faces (colors, fonts, etc.) used by Font Lock for
+fontifying different parts of buffer text, use \\[customize-face].
 
-Where modes support different levels of fontification, you can use the variable
+You can enable Font Lock mode in any major mode automatically by turning on in
+the major mode's hook.  For example, put in your ~/.emacs:
+
+ (add-hook 'c-mode-hook 'turn-on-font-lock)
+
+Alternatively, you can use Global Font Lock mode to automagically turn on Font
+Lock mode in buffers whose major mode supports it and whose major mode is one
+of `font-lock-global-modes'.  For example, put in your ~/.emacs:
+
+ (global-font-lock-mode t)
+
+There are a number of support modes that may be used to speed up Font Lock mode
+in various ways, specified via the variable `font-lock-support-mode'.  Where
+major modes support different levels of fontification, you can use the variable
 `font-lock-maximum-decoration' to specify which level you generally prefer.
 When you turn Font Lock mode on/off the buffer is fontified/defontified, though
 fontification occurs only if the buffer is less than `font-lock-maximum-size'.
-To fontify a buffer without turning on Font Lock mode, and regardless of buffer
+
+For example, to specify that Font Lock mode use use Lazy Lock mode as a support
+mode and use maximum levels of fontification, put in your ~/.emacs:
+
+ (setq font-lock-support-mode 'lazy-lock-mode)
+ (setq font-lock-maximum-decoration t)
+
+To add your own highlighting for some major mode, and modify the highlighting
+selected automatically via the variable `font-lock-maximum-decoration', you can
+use `font-lock-add-keywords'.
+
+To fontify a buffer, without turning on Font Lock mode and regardless of buffer
 size, you can use \\[font-lock-fontify-buffer].
 
-See the variable `font-lock-keywords' for customization."
-  (interactive "P")
-  (let ((on-p (if arg (> (prefix-numeric-value arg) 0) (not font-lock-mode)))
-	(maximum-size (if (not (consp font-lock-maximum-size))
-			  font-lock-maximum-size
-			(cdr (or (assq major-mode font-lock-maximum-size)
-				 (assq t font-lock-maximum-size))))))
-    ;; Font-lock mode will refuse to turn itself on if in batch mode
-    ;; to avoid potential (probably not actual, though) slowdown.  We
-    ;; used to try to "be nice" by avoiding doing this in temporary
-    ;; buffers.  But with the deferral code we don't need this, and it
-    ;; definitely screws some things up.
-    (if (noninteractive)
-	(setq on-p nil))
-    (cond (on-p
-	   (make-local-hook 'after-change-functions)
-	   (add-hook 'after-change-functions
-		     'font-lock-after-change-function nil t)
-	   (add-hook 'pre-idle-hook 'font-lock-pre-idle-hook))
-	  (t
-	   (remove-hook 'after-change-functions
-			'font-lock-after-change-function t)
-	   (setq font-lock-defaults-computed nil
-		 font-lock-keywords nil)
-	   ;; We have no business doing this here, since 
-	   ;; pre-idle-hook is global.	Other buffers may
-	   ;; still be in font-lock mode.  -dkindred@cs.cmu.edu
-	   ;; (remove-hook 'pre-idle-hook 'font-lock-pre-idle-hook)
-	   ))
-    (set (make-local-variable 'font-lock-mode) on-p)
-    (cond (on-p
-	   (font-lock-set-defaults-1)
-	   (run-hooks 'font-lock-mode-hook)
-	   (cond (font-lock-fontified
-		  nil)
-		 ((or (null maximum-size) (<= (buffer-size) maximum-size))
-		  (font-lock-fontify-buffer))
-		 (font-lock-verbose
-		  (progress-feedback-with-label
-		   'font-lock
-		   "Fontifying %s... buffer too big." 'abort
-		   (buffer-name)))))
-	  (font-lock-fontified
-	   (setq font-lock-fontified nil)
-	   (font-lock-unfontify-region (point-min) (point-max))
-	   (font-lock-thing-lock-cleanup))
-	  (t
-	   (font-lock-thing-lock-cleanup)))
-    (redraw-modeline)))
+To fontify a block (the function or paragraph containing point, or a number of
+lines around point), perhaps because modification on the current line caused
+syntactic change on other lines, you can use \\[font-lock-fontify-block].
+
+The Font Lock mode default settings can be found by retrieving a property
+named `font-lock-defaults' on the symbol naming the major mode.  You can
+set your own default settings for some mode, by setting a buffer local
+value for `font-lock-defaults', via its mode hook.
+
+See the variable `font-lock-keywords' for a description of the format of
+the settings."
+  nil nil nil
+  ;; Font-lock mode will refuse to turn itself on if in batch mode to avoid
+  ;; potential (probably not actual, though) slowdown.  We used to try to
+  ;; "be nice" by avoiding doing this in temporary (aka invisible) buffers.
+  ;; But with the deferral code we don't need this, and it definitely
+  ;; screws some things up.
+  (when (or (noninteractive)
+	    ;; (eq (aref (buffer-name) 0) ?\ ))
+	    )
+    (setq font-lock-mode nil))
+
+  ;; Turn on Font Lock mode.
+  (when font-lock-mode
+    (add-hook 'after-change-functions 'font-lock-after-change-function t t)
+    (add-hook 'pre-idle-hook 'font-lock-pre-idle-hook)
+    (font-lock-set-defaults)
+    (font-lock-turn-on-thing-lock)
+    ;; Fontify the buffer if we have to.
+    (let ((max-size (font-lock-value-in-major-mode font-lock-maximum-size)))
+      (cond (font-lock-fontified
+	     nil)
+	    ((or (null max-size) (> max-size (buffer-size)))
+	     (font-lock-fontify-buffer))
+	    (font-lock-verbose
+	     (progress-feedback-with-label
+	      'font-lock
+	      "Fontifying %s...buffer too big." 'abort
+	      (buffer-name))))))
+
+  ;; Turn off Font Lock mode.
+  (unless font-lock-mode
+    (remove-hook 'after-change-functions 'font-lock-after-change-function t)
+    ;; We have no business doing this here, since 
+    ;; pre-idle-hook is global.	Other buffers may
+    ;; still be in font-lock mode.  -dkindred@cs.cmu.edu
+    ;; (remove-hook 'pre-idle-hook 'font-lock-pre-idle-hook)
+    (font-lock-unfontify-buffer)
+    (font-lock-turn-off-thing-lock)
+    (font-lock-unset-defaults)))
 
 ;; For init-file hooks
 ;;;###autoload
 (defun turn-on-font-lock ()
   "Unconditionally turn on Font Lock mode."
   (interactive)
-  (font-lock-mode 1))
+  (unless font-lock-mode
+    (font-lock-mode)))
 
 ;;;###autoload
 (defun turn-off-font-lock ()
   "Unconditionally turn off Font Lock mode."
   (interactive)
-  (font-lock-mode 0))
+  (when font-lock-mode
+    (font-lock-mode)))
+
+;;;###autoload
+(defun font-lock-add-keywords (mode keywords &optional append)
+  "Add highlighting KEYWORDS for MODE.
+MODE should be a symbol, the major mode command name, such as `c-mode'
+or nil.  If nil, highlighting keywords are added for the current buffer.
+KEYWORDS should be a list; see the variable `font-lock-keywords'.
+By default they are added at the beginning of the current highlighting list.
+If optional argument APPEND is `set', they are used to replace the current
+highlighting list.  If APPEND is any other non-nil value, they are added at the
+end of the current highlighting list.
+
+For example:
+
+ (font-lock-add-keywords 'c-mode
+  '((\"\\\\\\=<\\\\(FIXME\\\\):\" 1 font-lock-warning-face prepend)
+    (\"\\\\\\=<\\\\(and\\\\|or\\\\|not\\\\)\\\\\\=>\" . font-lock-keyword-face)))
+
+adds two fontification patterns for C mode, to fontify `FIXME:' words, even in
+comments, and to fontify `and', `or' and `not' words as keywords.
+
+When used from an elisp package (such as a minor mode), it is recommended
+to use nil for MODE (and place the call in a loop or on a hook) to avoid
+subtle problems due to details of the implementation.
+
+Note that some modes have specialised support for additional patterns, e.g.,
+see the variables `c-font-lock-extra-types', `c++-font-lock-extra-types',
+`objc-font-lock-extra-types' and `java-font-lock-extra-types'."
+  (cond (mode
+	 ;; If MODE is non-nil, add the KEYWORDS and APPEND spec to
+	 ;; `font-lock-keywords-alist' so `font-lock-set-defaults' uses them.
+	 (let ((spec (cons keywords append)) cell)
+	   (if (setq cell (assq mode font-lock-keywords-alist))
+	       (if (eq append 'set)
+		   (setcdr cell (list spec))
+		 (setcdr cell (append (cdr cell) (list spec))))
+	     (push (list mode spec) font-lock-keywords-alist)))
+	 ;; Make sure that `font-lock-removed-keywords-alist' does not
+	 ;; contain the new keywords.
+	 (font-lock-update-removed-keyword-alist mode keywords append))
+	(t
+	 ;; Otherwise set or add the keywords now.
+	 (font-lock-set-defaults)
+ 	 (if (eq append 'set)
+ 	     (setq font-lock-keywords keywords)
+	   (font-lock-remove-keywords nil keywords) ;to avoid duplicates
+	   (let ((old (if (eq (car-safe font-lock-keywords) t)
+			  (cdr font-lock-keywords)
+			font-lock-keywords)))
+	     (setq font-lock-keywords (if append
+					  (append old keywords)
+					(append keywords old))))))))
+
+(defun font-lock-update-removed-keyword-alist (mode keywords append)
+  ;; Update `font-lock-removed-keywords-alist' when adding new
+  ;; KEYWORDS to MODE.
+  ;;
+  ;; When font-lock is enabled first all keywords in the list
+  ;; `font-lock-keywords-alist' are added, then all keywords in the
+  ;; list `font-lock-removed-keywords-alist' are removed.  If a
+  ;; keyword was once added, removed, and then added again it must be
+  ;; removed from the removed-keywords list.  Otherwise the second add
+  ;; will not take effect.
+  (let ((cell (assq mode font-lock-removed-keywords-alist)))
+    (if cell
+	(if (eq append 'set)
+	    ;; A new set of keywords is defined.  Forget all about
+	    ;; our old keywords that should be removed.
+	    (setq font-lock-removed-keywords-alist
+		  (delq cell font-lock-removed-keywords-alist))
+	  ;; Delete all previously removed keywords.
+	  (dolist (kword keywords)
+	    (setcdr cell (delete kword (cdr cell))))
+	  ;; Delete the mode cell if empty.
+	  (if (null (cdr cell))
+	      (setq font-lock-removed-keywords-alist
+		    (delq cell font-lock-removed-keywords-alist)))))))
+
+;; Written by Anders Lindgren <andersl@andersl.com>.
+;;
+;; Case study:
+;; (I)  The keywords are removed from a major mode.
+;;      In this case the keyword could be local (i.e. added earlier by
+;;      `font-lock-add-keywords'), global, or both.
+;;
+;;      (a) In the local case we remove the keywords from the variable
+;;          `font-lock-keywords-alist'.
+;;
+;;      (b) The actual global keywords are not known at this time.
+;;          All keywords are added to `font-lock-removed-keywords-alist',
+;;          when font-lock is enabled those keywords are removed.
+;;
+;;      Note that added keywords are taken out of the list of removed
+;;      keywords.  This ensure correct operation when the same keyword
+;;      is added and removed several times.
+;;
+;; (II) The keywords are removed from the current buffer.
+;;;###autoload
+(defun font-lock-remove-keywords (mode keywords)
+  "Remove highlighting KEYWORDS for MODE.
 
-;;; FSF has here:
+MODE should be a symbol, the major mode command name, such as `c-mode'
+or nil.  If nil, highlighting keywords are removed for the current buffer.
 
-;; support for add-keywords, global-font-lock-mode and
-;; font-lock-support-mode (unified support for various *-lock modes).
+When used from an elisp package (such as a minor mode), it is recommended
+to use nil for MODE (and place the call in a loop or on a hook) to avoid
+subtle problems due to details of the implementation."
+  (cond (mode
+	 ;; Remove one keyword at the time.
+	 (dolist (keyword keywords)
+	   (let ((top-cell (assq mode font-lock-keywords-alist)))
+	     ;; If MODE is non-nil, remove the KEYWORD from
+	     ;; `font-lock-keywords-alist'.
+	     (when top-cell
+	       (dolist (keyword-list-append-pair (cdr top-cell))
+		 ;; `keywords-list-append-pair' is a cons with a list of
+		 ;; keywords in the car top-cell and the original append
+		 ;; argument in the cdr top-cell.
+		 (setcar keyword-list-append-pair
+			 (delete keyword (car keyword-list-append-pair))))
+	       ;; Remove keyword list/append pair when the keyword list
+	       ;; is empty and append doesn't specify `set'.  (If it
+	       ;; should be deleted then previously deleted keywords
+	       ;; would appear again.)
+	       (let ((cell top-cell))
+		 (while (cdr cell)
+		   (if (and (null (car (car (cdr cell))))
+			    (not (eq (cdr (car (cdr cell))) 'set)))
+		       (setcdr cell (cdr (cdr cell)))
+		     (setq cell (cdr cell)))))
+	       ;; Final cleanup, remove major mode cell if last keyword
+	       ;; was deleted.
+	       (if (null (cdr top-cell))
+		   (setq font-lock-keywords-alist
+			 (delq top-cell font-lock-keywords-alist))))
+	     ;; Remember the keyword in case it is not local.
+	     (let ((cell (assq mode font-lock-removed-keywords-alist)))
+	       (if cell
+		   (unless (member keyword (cdr cell))
+		     (nconc cell (list keyword)))
+		 (push (cons mode (list keyword))
+		       font-lock-removed-keywords-alist))))))
+	(t
+	 ;; Otherwise remove it immediately.
+	 (font-lock-set-defaults)
+	 (setq font-lock-keywords (copy-sequence font-lock-keywords))
+	 (dolist (keyword keywords)
+	   (setq font-lock-keywords
+		 (delete keyword
+			 ;; The keywords might be compiled.
+			 (delete (font-lock-compile-keyword keyword)
+				 font-lock-keywords)))))))
+
+;;; Global Font Lock mode.
+
+;; XEmacs: Formerly, we had a mechanism where, if `font-lock-auto-fontify' was
+;; non-nil, loading `font-lock' automatically turned on font lock and
+;; insinuated itself into various modes -- all by default for which font-lock
+;; had keywords. Variables `font-lock-mode-enable-list' or
+;; `font-lock-mode-disable-list' could get you finer-grained control.  The new
+;; scheme is clearly better -- instead of having a one-time non-reversible way
+;; of turning on font-lock for many modes, and the no-no of having things
+;; automatically happen when a file is loaded, there's a
+;; `global-font-lock-mode' to turn font lock on and off globally whenever you
+;; want.  The new `font-lock-global-modes' is allows for finer grained control
+;; ala the two lists we had before.  We could try to implement backwards
+;; compatibility for the lists, but since we can't (and won't) be
+;; backwards-compatible with `font-lock-auto-fontify' and the automagical
+;; behavior of loading font-lock, we may as well just make the user adjust
+;; completely to the new scheme.  It's not hard by any means.  We should be
+;; able to keep option menu compatibility, though.
+
+;; Old variables:
+
+; ;;;###autoload
+; (defcustom font-lock-auto-fontify t
+;   "*Whether font-lock should automatically fontify files as they're loaded.
+; This will only happen if font-lock has fontifying keywords for the major
+; mode of the file.  You can get finer-grained control over auto-fontification
+; by using this variable in combination with `font-lock-mode-enable-list' or
+; `font-lock-mode-disable-list'."
+;:type 'boolean
+;:group 'font-lock)
+
+; ;;;###autoload
+; (defcustom font-lock-mode-enable-list nil
+;   "*List of modes to auto-fontify, if `font-lock-auto-fontify' is nil."
+;:type '(repeat (symbol :tag "Mode"))
+;:group 'font-lock)
+
+; ;;;###autoload
+; (defcustom font-lock-mode-disable-list nil
+;   "*List of modes not to auto-fontify, if `font-lock-auto-fontify' is t."
+;:type '(repeat (symbol :tag "Mode"))
+;:group 'font-lock)
+
+;; A few people have hassled in the past for a way to make it easier to turn on
+;; Font Lock mode, without the user needing to know for which modes s/he has to
+;; turn it on, perhaps the same way hilit19.el/hl319.el does.  I've always
+;; balked at that way, as I see it as just re-moulding the same problem in
+;; another form.  That is; some person would still have to keep track of which
+;; modes (which may not even be distributed with Emacs) support Font Lock mode.
+;; The list would always be out of date.  And that person might have to be me.
 
+;; Implementation.
+;;
+;; In a previous discussion the following hack came to mind.  It is a gross
+;; hack, but it generally works.  We use the convention that major modes start
+;; by calling the function `kill-all-local-variables', which in turn runs
+;; functions on the hook variable `change-major-mode-hook'.  We attach our
+;; function `font-lock-change-major-mode' to that hook.  Of course, when this
+;; hook is run, the major mode is in the process of being changed and we do not
+;; know what the final major mode will be.  So, `font-lock-change-major-mode'
+;; only (a) notes the name of the current buffer, and (b) adds our function
+;; `turn-on-font-lock-if-enabled' to the hook variables `find-file-hooks' and
+;; `post-command-hook' (for buffers that are not visiting files).  By the time
+;; the functions on the first of these hooks to be run are run, the new major
+;; mode is assumed to be in place.  This way we get a Font Lock function run
+;; when a major mode is turned on, without knowing major modes or their hooks.
+;;
+;; Naturally this requires that (a) major modes run `kill-all-local-variables',
+;; as they are supposed to do, and (b) the major mode is in place after the
+;; file is visited or the command that ran `kill-all-local-variables' has
+;; finished, whichever the sooner.  Arguably, any major mode that does not
+;; follow the convension (a) is broken, and I can't think of any reason why (b)
+;; would not be met (except `gnudoit' on non-files).  However, it is not clean.
+;;
+;; Probably the cleanest solution is to have each major mode function run some
+;; hook, e.g., `major-mode-hook', but maybe implementing that change is
+;; impractical.  I am personally against making `setq' a macro or be advised,
+;; or have a special function such as `set-major-mode', but maybe someone can
+;; come up with another solution?
+
+;; User interface.
+;;
+;; Although Global Font Lock mode is a pseudo-mode, I think that the user
+;; interface should conform to the usual Emacs convention for modes, i.e., a
+;; command to toggle the feature (`global-font-lock-mode') with a variable for
+;; finer control of the mode's behaviour (`font-lock-global-modes').
+;;
+;; The feature should not be enabled by loading font-lock.el, since other
+;; mechanisms for turning on Font Lock mode, such as M-x font-lock-mode RET or
+;; (add-hook 'c-mode-hook 'turn-on-font-lock), would cause Font Lock mode to be
+;; turned on everywhere.  That would not be intuitive or informative because
+;; loading a file tells you nothing about the feature or how to control it.  It
+;; would also be contrary to the Principle of Least Surprise.  sm.
+
+(defcustom font-lock-global-modes t
+  "*Modes for which Font Lock mode is automagically turned on.
+Global Font Lock mode is controlled by the command `global-font-lock-mode'.
+If nil, means no modes have Font Lock mode automatically turned on.
+If t, all modes that support Font Lock mode have it automatically turned on.
+If a list, it should be a list of `major-mode' symbol names for which Font Lock
+mode should be automatically turned on.  The sense of the list is negated if it
+begins with `not'.  For example:
+ (c-mode c++-mode)
+means that Font Lock mode is turned on for buffers in C and C++ modes only."
+:type '(choice (const :tag "none" nil)
+		 (const :tag "all" t)
+		 (set :menu-tag "mode specific" :tag "modes"
+		      :value (not)
+		      (const :tag "Except" not)
+		      (repeat :inline t (symbol :tag "mode"))))
+:group 'font-lock)
+
+(defun turn-on-font-lock-if-enabled ()
+  (when (and (or font-lock-defaults
+		 (font-lock-find-font-lock-defaults major-mode))
+	     (or (eq font-lock-global-modes t)
+		 (if (eq (car-safe font-lock-global-modes) 'not)
+		     (not (memq major-mode (cdr font-lock-global-modes)))
+		   (memq major-mode font-lock-global-modes))))
+    (let (inhibit-quit)
+      (turn-on-font-lock))))
+
+;;;###autoload
+(easy-mmode-define-global-mode
+ global-font-lock-mode font-lock-mode turn-on-font-lock-if-enabled
+:extra-args (dummy))
+
+;;; End of Global Font Lock mode.
 
-;; Fontification functions.
+;;; Font Lock Support mode.
+
+;; This is the code used to interface font-lock.el with any of its add-on
+;; packages, and provide the user interface.  Packages that have their own
+;; local buffer fontification functions (see below) may have to call
+;; `font-lock-after-fontify-buffer' and/or `font-lock-after-unfontify-buffer'
+;; themselves.
+
+(defcustom font-lock-support-mode 'lazy-lock-mode
+  "*Support mode for Font Lock mode.
+Support modes speed up Font Lock mode by being choosy about when
+fontification occurs.  Known support modes are Fast Lock mode (symbol
+`fast-lock-mode'), Lazy Lock mode (symbol `lazy-lock-mode'), Lazy Shot mode
+\(symbol `lazy-shot-mode'), and Just-in-time Lock mode (symbol
+`jit-lock-mode').  See those modes for more info.
+If nil, means support for Font Lock mode is never performed.
+If a symbol, use that support mode.
+If a list, each element should be of the form (MAJOR-MODE . SUPPORT-MODE),
+where MAJOR-MODE is a symbol or t (meaning the default).  For example:
+ ((c-mode . fast-lock-mode) (c++-mode . fast-lock-mode) (t . lazy-lock-mode))
+means that Fast Lock mode is used to support Font Lock mode for buffers in C or
+C++ modes, and Lazy Lock mode is used to support Font Lock mode otherwise.
+
+The value of this variable is used when Font Lock mode is turned on."
+:type '(choice (const :tag "none" nil)
+		 (const :tag "fast lock" fast-lock-mode)
+		 (const :tag "lazy lock" lazy-lock-mode)
+		 (const :tag "lazy shot" lazy-shot-mode)
+		 (const :tag "jit lock" jit-lock-mode)
+		 (repeat :menu-tag "mode specific" :tag "mode specific"
+			 :value ((t . jit-lock-mode))
+			 (cons :tag "Instance"
+			       (radio :tag "Mode"
+				      (const :tag "all" t)
+				      (symbol :tag "name"))
+			       (radio :tag "Support"
+				      (const :tag "none" nil)
+				      (const :tag "fast lock" fast-lock-mode)
+				      (const :tag "lazy lock" lazy-lock-mode)
+				      (const :tag "lazy shot" lazy-shot-mode)
+				      (const :tag "JIT lock" jit-lock-mode)))
+			 ))
+:version "21.1"
+:group 'font-lock)
+
+(defvar fast-lock-mode nil)
+(defvar lazy-lock-mode nil)
+(defvar lazy-shot-mode nil)
+(defvar jit-lock-mode nil)
+
+(defun font-lock-turn-on-thing-lock ()
+  (let ((thing-mode (font-lock-value-in-major-mode font-lock-support-mode)))
+    (cond ((eq thing-mode 'fast-lock-mode)
+	   (declare-fboundp (fast-lock-mode t)))
+	  ((eq thing-mode 'lazy-lock-mode)
+	   (declare-fboundp (lazy-lock-mode t)))
+	  ((eq thing-mode 'lazy-shot-mode)
+	   (declare-fboundp (lazy-shot-mode t)))
+	  ((eq thing-mode 'jit-lock-mode)
+	   ;; Prepare for jit-lock
+	   (remove-hook 'after-change-functions
+			'font-lock-after-change-function t)
+	   (set (make-local-variable 'font-lock-fontify-buffer-function)
+		'jit-lock-refontify)
+	   ;; Don't fontify eagerly (and don't abort is the buffer is large).
+	   (set (make-local-variable 'font-lock-fontified) t)
+	   ;; Use jit-lock.
+	   (declare-fboundp
+	    (jit-lock-register 'font-lock-fontify-region
+			       (not font-lock-keywords-only)))))))
+
+(defun font-lock-turn-off-thing-lock ()
+  (cond (fast-lock-mode
+	 (declare-fboundp (fast-lock-mode -1)))
+	(jit-lock-mode
+	 (declare-fboundp
+	  (jit-lock-unregister 'font-lock-fontify-region))
+	 ;; Reset local vars to the non-jit-lock case.
+	 (kill-local-variable 'font-lock-fontify-buffer-function))
+	(lazy-lock-mode
+	 (declare-fboundp (lazy-lock-mode -1)))
+	(lazy-shot-mode
+	 (declare-fboundp (lazy-shot-mode -1)))))
+
+
+;; Various functions.
+
+;; FSF, for inexplicable reasons that make sense only to rms, does not use a
+;; hook for obvious hook-like functions, instead hard-coding the calls.
+;; There's really no reason to be this bizarre so we go ahead and have hooks.
+
+;; Turn off other related packages if they're on.  I prefer a hook. --sm.
+;; These explicit calls are easier to understand
+;; because people know what they will do.
+;; A hook is a mystery because it might do anything whatever. --rms.
+
+
+(defun font-lock-after-fontify-buffer ()
+  (run-hooks 'font-lock-after-fontify-buffer-hook)
+;   (cond ((and-boundp 'fast-lock-mode fast-lock-mode)
+; 	 (declare-fboundp (fast-lock-after-fontify-buffer)))
+; 	;; Useless now that jit-lock intercepts font-lock-fontify-buffer.  -sm
+; 	;;((and-boundp 'jit-lock-mode jit-lock-mode)
+; 	;; (declare-fboundp (jit-lock-after-fontify-buffer)))
+; 	((and-boundp 'lazy-lock-mode lazy-lock-mode)
+; 	 (declare-fboundp (lazy-lock-after-fontify-buffer))))
+  )
 
+(defun font-lock-after-unfontify-buffer ()
+  (run-hooks 'font-lock-after-unfontify-buffer-hook)
+;   (cond ((and-boundp 'fast-lock-mode fast-lock-mode)
+; 	 (declare-fboundp (fast-lock-after-unfontify-buffer)))
+; 	;; Useless as well.  It's only called when:
+; 	;; - turning off font-lock: it does not matter if we leave spurious
+; 	;;   `fontified' text props around since jit-lock-mode is also off.
+; 	;; - font-lock-default-fontify-buffer fails: this is not run
+; 	;;   any more anyway.   -sm
+; 	;;
+; 	;;((and-boundp 'jit-lock-mode jit-lock-mode)
+; 	;; (declare-fboundp (jit-lock-after-unfontify-buffer)))
+; 	((and-boundp 'lazy-lock-mode lazy-lock-mode)
+; 	 (declare-fboundp (lazy-lock-after-unfontify-buffer))))
+  )
+
+;;; End of Font Lock Support mode.
+
+
 ;; We first define some defsubsts to encapsulate the way we add
 ;; faces to a region of text.  I am planning on modifying the
 ;; text-property mechanism so that multiple independent classes
@@ -1026,9 +1563,7 @@
 (defsubst font-lock-remove-face (start end)
   ;; Remove any syntax highlighting on the characters in the range.
   (put-nonduplicable-text-property start end 'face nil)
-  (put-nonduplicable-text-property start end 'font-lock nil)
-  (if lookup-syntax-properties
-      (put-nonduplicable-text-property start end 'syntax-table nil)))
+  (put-nonduplicable-text-property start end 'font-lock nil))
 
 (defsubst font-lock-set-syntax (start end syntax)
   ;; Set the face on the characters in the range.
@@ -1052,6 +1587,7 @@
   ;; of `text-property-not-all'.  #### If so, `text-property-not-all'
   ;; should be fixed ...
   ;;
+  ;;(text-property-not-all start end 'font-lock nil)
   (map-extents 'extent-property (current-buffer) start (1- end) 'font-lock))
 
 
@@ -1099,8 +1635,6 @@
 ;;;###autoload
 (defun font-lock-fontify-buffer ()
   "Fontify the current buffer the way `font-lock-mode' would.
-See `font-lock-mode' for details.
-
 This can take a while for large buffers."
   (interactive)
   (let ((font-lock-verbose (or font-lock-verbose (interactive-p))))
